Index: EXAMPLES/Makefile
===================================================================
--- EXAMPLES/Makefile	(revision 30644a99f80dea7632b443184c004f514fccf1d8)
+++ EXAMPLES/Makefile	(revision 6650a56b8f862383b669bf41c64d328acf404e72)
@@ -17,7 +17,7 @@
 # Linker flags
 # Default flags, e.g., for gfortran, g77
-L_FLAGS=-O2 -g
+# L_FLAGS=-O2 -g
 # Flags for Intel's ifort
-# L_FLAGS=-O3 -axW -g
+L_FLAGS=-O3 -axW -g
 # FLAGS for Cray
 # L_FLAGS=-fastsse -Mipa
@@ -27,7 +27,7 @@
 # Compiler flags
 # Default flags, e.g., for gfortran, g77
-F_FLAGS=-c -O2 -g
+# F_FLAGS=-c -O2 -g
 # Flags for Intel's ifort
-# F_FLAGS=-c -O3 -axW -g
+F_FLAGS=-c -O3 -axW -g
 # Flags for debugging build
 # F_FLAGS=-c -O0 -g
@@ -38,6 +38,6 @@
 # F_FLAGS=-c -fPIC -O3 -funroll-loops -mmmx -msse2 -msse -march=i686 -malign-double -fomit-frame-pointer
 # Select your compiler
-F90=gfortran
-#F90=ifort
+# F90=gfortran
+F90=ifort
 #F90=pgf90
 #F90=xlf
Index: EXAMPLES/multicanonical.f
===================================================================
--- EXAMPLES/multicanonical.f	(revision 30644a99f80dea7632b443184c004f514fccf1d8)
+++ EXAMPLES/multicanonical.f	(revision 6650a56b8f862383b669bf41c64d328acf404e72)
@@ -31,5 +31,5 @@
 !     Change the following directory path to where you want to put SMMP
 !     libraries of residues. 
-      libdir='../SMMP/'
+      libdir='../../SMMP/'
 
 !!     Choose energy type with the following switch
@@ -58,5 +58,5 @@
       iabin = 1  ! =0: read from PDB-file
                  ! =1: ab Initio from sequence (& variables)
-      seqfile='enkefa.seq'
+      seqfile='1vp.seq'
 !      varfile='EXAMPLES/enkefa.var'
       varfile = ' '
@@ -77,10 +77,10 @@
       temp=1000.0
 
-      call mulcan_par(nsweeps, nup, temp, kmin, kmax, binWidth, l_iter)
+!      call mulcan_par(nsweeps, nup, temp, kmin, kmax, binWidth, l_iter)
 ! Uncomment the following three lines to perform a multi canonical simulation with
 ! the parameters stored in muca.d
-!       nmes = 1000
-!       call mulcan_sim(nmes, nsweeps, nmes, nup, kmin, kmax, binWidth, 
-!      &                l_iter)
+       nmes = 1000
+       call mulcan_sim(nmes, nsweeps, nmes, nup, kmin, kmax, binWidth, 
+     &                l_iter)
       end program multicanonical_main
 
Index: INCP.H
===================================================================
--- INCP.H	(revision 30644a99f80dea7632b443184c004f514fccf1d8)
+++ INCP.H	(revision 6650a56b8f862383b669bf41c64d328acf404e72)
@@ -2,4 +2,8 @@
 ! contents of a PDB file
 ! ......................
+      integer MXCHP, MXRSP, MXATP, nchp, nchrsp, nrsp, irsatp, nrsatp
+      integer natp, noatp
+      
+      double precision xatp, yatp, zatp
 
       parameter (MXCHP =100,    ! max. no. of polypeptide chains
Index: anneal.f
===================================================================
--- anneal.f	(revision 30644a99f80dea7632b443184c004f514fccf1d8)
+++ anneal.f	(revision 6650a56b8f862383b669bf41c64d328acf404e72)
@@ -32,4 +32,10 @@
 !     external rand
       external can_weight
+      
+      double precision bmin, bmax, db, dv, grnd, vr, addang, eol, energy
+      double precision acz, ymin, vlvrm, rgy, ee, temp
+
+      integer nresi, i, iv, nsw, nemin, j
+      
 !      parameter(lrand=.true.)
 !      parameter(nequi=100, nswp=100000,nmes=1000)
Index: canon.f
===================================================================
--- canon.f	(revision 30644a99f80dea7632b443184c004f514fccf1d8)
+++ canon.f	(revision 6650a56b8f862383b669bf41c64d328acf404e72)
@@ -27,4 +27,9 @@
 !     external rand
       external can_weight
+      
+      double precision dv, grnd, vr, addang, eol, energy, acz, rgy, ee
+
+      integer i, iv, nsw, nhel, mhel, nbet, mbet, mhb
+
      
       logical lrand
@@ -132,6 +137,7 @@
 ! CALLS: none
 !
+      implicit none
+      double precision beta, x
 
-      implicit real*8 (a-h,o-z) 
 
       common/bet/beta
Index: doc/manual.lyx
===================================================================
--- doc/manual.lyx	(revision 30644a99f80dea7632b443184c004f514fccf1d8)
+++ doc/manual.lyx	(revision 6650a56b8f862383b669bf41c64d328acf404e72)
@@ -1,3 +1,3 @@
-#LyX 1.5.0rc2 created this file. For more info see http://www.lyx.org/
+#LyX 1.5.6 created this file. For more info see http://www.lyx.org/
 \lyxformat 276
 \begin_document
@@ -39,5 +39,6 @@
 \tracking_changes false
 \output_changes false
-\author "Jan H. Meinke" 
+\author "" 
+\author "" 
 \end_header
 
@@ -2536,5 +2537,11 @@
  original ECEPP/2/3 and FLEX potentials.
  However, it should be noted that SMMP has its own numeration of the atom
- types and the types of torsions (see [1,2] for more details).
+ types and the types of torsions (see 
+\begin_inset LatexCommand cite
+key "Eisenmenger2001,Eisenmenger2006"
+
+\end_inset
+
+ for more details).
 \end_layout
 
Index: helix.f
===================================================================
--- helix.f	(revision 30644a99f80dea7632b443184c004f514fccf1d8)
+++ helix.f	(revision 6650a56b8f862383b669bf41c64d328acf404e72)
@@ -27,4 +27,8 @@
            
       logical lhel,lbet
+      double precision hlim, philim, psilim, hlim2, philim2, psilim2
+      double precision xphi, xpsi
+
+      integer nhel, mhel, nbet, mbet, i, iv
 
       parameter(hlim=30.0d0,philim=-70.0d0,psilim=-37.0d0)
Index: incl_lund.h
===================================================================
--- incl_lund.h	(revision 30644a99f80dea7632b443184c004f514fccf1d8)
+++ incl_lund.h	(revision 6650a56b8f862383b669bf41c64d328acf404e72)
@@ -1,2 +1,3 @@
+      integer nhptyp, mxconr, mxcell, iN, iCa, iC, mlvr, iphi, ipsi
       parameter (nhptyp=3,mxconr=40,mxcell=125000)
       dimension iN(mxrs),iCa(mxrs),iC(mxrs),mlvr(mxvr)
@@ -13,4 +14,5 @@
       common /bgs_i/ bgsnvar,iph
       common /bgs_r/ abgs,bbgs,dph, bgsvar
+      integer ihpat, nhpat
       dimension ihpat(mxrs,6),nhpat(mxrs)
       double precision hpstrg
@@ -18,4 +20,5 @@
       
       double precision exvk,exvcut,exvcut2
+      integer matcon
       dimension matcon(-mxconr:mxconr,mxat)
 
@@ -30,5 +33,5 @@
       dimension sig2exv(mxtyat,mxtyat)
       dimension asaexv(mxtyat,mxtyat),bsaexv(mxtyat,mxtyat)
-
+      integer lcp1, lcp2, ilpst, ilpnd
       common /lundff/kbias,                                             &
      &     epshb1,epshb2,powa,powb,sighb,cthb,                          &
Index: init_lund.f90
===================================================================
--- init_lund.f90	(revision 30644a99f80dea7632b443184c004f514fccf1d8)
+++ init_lund.f90	(revision 6650a56b8f862383b669bf41c64d328acf404e72)
@@ -6,4 +6,6 @@
     include 'INCL.H'
     include 'incl_lund.h'
+    integer i, npprs, j, k
+
     logical bgsposs
     do i=1,mxrs
Index: minqsn.f
===================================================================
--- minqsn.f	(revision 30644a99f80dea7632b443184c004f514fccf1d8)
+++ minqsn.f	(revision 6650a56b8f862383b669bf41c64d328acf404e72)
@@ -56,6 +56,14 @@
 ! .............................................................
 
-      implicit real*8 (a-h,o-z)
-      implicit integer*4 (i-n)
+      implicit none
+
+      double precision eps1, eps2, tiny, zero, dff, c, g, scal, h, fa, f
+      double precision xa, x, ga, d, w, dga, di, fmin, gmin, stmin
+      double precision stepub, steplb, acur, step, xb, fb, gb, gl1, gl2
+      double precision si, dgb, sig
+
+      integer izero, ione, mxn, nfun, itr, i, n, n1, i1, j, isfv, maxfun
+      integer ir
+
 
       parameter ( eps1=0.1d0,
@@ -249,6 +257,9 @@
 ! CALLS: none
 !
-      implicit real*8 (a-h,o-z)
-      implicit integer*4 (i-n)
+      implicit none
+
+      double precision sig, ti, w, z, a, v, eps, tim, al, r, b, gm, y
+
+      integer mxn, n, ir, np, ij, mk, i, j, mm
 
       dimension a(mxn*(mxn+1)/2),z(mxn),w(mxn)
@@ -373,6 +384,8 @@
 ! CALLS: none
 !
-      implicit real*8 (a-h,o-z)
-      implicit integer*4 (i-n)
+      implicit none
+      double precision w, z, v, a
+
+      integer mxn, ir, n, i, ij, i1, j, np, nip, ii, ip
 
       dimension a(mxn*(mxn+1)/2),z(mxn),w(mxn)
Index: mklist.f
===================================================================
--- mklist.f	(revision 30644a99f80dea7632b443184c004f514fccf1d8)
+++ mklist.f	(revision 6650a56b8f862383b669bf41c64d328acf404e72)
@@ -310,5 +310,6 @@
 ! ....................................................
 
-      implicit integer*4 (i-n)
+      implicit none
+      integer mx, j, n, j1, l1, j2, l2, i1, i2, ja, k
 
       dimension l1(mx),l2(mx)
Index: mulcan_par_mod.f90
===================================================================
--- mulcan_par_mod.f90	(revision 30644a99f80dea7632b443184c004f514fccf1d8)
+++ mulcan_par_mod.f90	(revision 6650a56b8f862383b669bf41c64d328acf404e72)
@@ -44,5 +44,7 @@
       real*8, intent(in) :: binWidth, temp
       logical,  intent(in) :: l_iter
-
+      
+      double precision :: grnd, addang, eol, energy
+      
       integer :: i,j
       integer :: iv,nsw,muold
@@ -214,5 +216,8 @@
       real*8, allocatable :: xhist(:),g1(:),ent(:)
       integer, allocatable :: ihist(:)
-
+      
+      double precision :: eol_old, x, grnd, addang, eol, energy, dham
+
+      integer :: nresi, nswm, nhy, nhx
       integer :: i,j
       integer :: iv,nsw,muold
Index: opesol.f
===================================================================
--- opesol.f	(revision 30644a99f80dea7632b443184c004f514fccf1d8)
+++ opesol.f	(revision 6650a56b8f862383b669bf41c64d328acf404e72)
@@ -32,5 +32,12 @@
 
       include 'INCL.H'
-
+      double precision xfvr, yfvr, zfvr, xfrvr, yfrvr, zfrvr, esolan, dx
+      double precision dy, dz, xfat, yfat, zfat, xi, yi, zi, xfrat
+      double precision yfrat, zfrat, xb, yb, zb, ex, ey, ez, xfiv, yfiv
+      double precision zfiv, xfriv, yfriv, zfriv
+
+      integer ntlvr, nml, ix2, ifivr, ilavr, i, i1s, i1a, io, iv, it, ia
+      integer ib, i2s, ims, i1, i2, i2a, iad, lad, ivw, j, i14
+      
       dimension xfat(mxat),yfat(mxat),zfat(mxat),
      &          xfrat(mxat),yfrat(mxat),zfrat(mxat),
@@ -244,4 +251,9 @@
 
       include 'INCL.H'
+      
+      double precision del, vlvrx, ovr, eynw, esolan, gda, gdn
+
+      integer i, it, iv, nml
+
 
       parameter (del=1.d-6)
Index: partem_p.f
===================================================================
--- partem_p.f	(revision 30644a99f80dea7632b443184c004f514fccf1d8)
+++ partem_p.f	(revision 6650a56b8f862383b669bf41c64d328acf404e72)
@@ -38,5 +38,14 @@
 !     nmes:   number of Monte Carlo sweeps between measurments
 !     newsta: .true. for new simulations, .false. for re-start
-
+      double precision temp, eavm, sph, geavm, gsph, dv, grnd, vr
+      double precision addang, dummy, eol, energy, acz, rmsv, rmsdfun
+      double precision rgy, ee, tmhb, dham, swp, wij, rd, e_final
+
+      integer ifrrm, nmes, nswp, num_rep, i, j, nresi, iold, inode
+      integer intem, iv, jold, idum1, idum2, idum3, mpi_integer
+      integer mpi_comm_world, ierr, mpi_double_precision, nsw, nequi
+      integer nml, nhel, mhel, nbet, mbet, mhb, imhb, nctot, ncnat
+      integer mpi_comm_null, k1, k, nu, no1, in, jn
+      
       dimension  eavm(MAX_PROC),sph(MAX_PROC),intem(MAX_PROC),
      &     inode(MAX_PROC), geavm(MAX_PROC), gsph(MAX_PROC)
Index: redstr.f
===================================================================
--- redstr.f	(revision 30644a99f80dea7632b443184c004f514fccf1d8)
+++ redstr.f	(revision 6650a56b8f862383b669bf41c64d328acf404e72)
@@ -27,4 +27,6 @@
 ! ..........................................................
       integer ib, ie, l
+      integer ln, is, ibegst, j, iendst
+
       character spr,blnk,str*(*),strn*(*)
       
@@ -91,6 +93,6 @@
 ! .............................................................
 
-      implicit integer*4 (i-n)
-
+      implicit none
+      integer i
       character blnk,str*(*)
       data blnk/' '/
@@ -117,6 +119,6 @@
 ! ..............................................................
 
-      implicit integer*4 (i-n)
-
+      implicit none
+      integer i
       character blnk,str*(*)
       data blnk/' '/
@@ -146,6 +148,6 @@
 ! ..........................................
 
-      implicit integer*4 (i-n)
-
+      implicit none
+      integer mxd, ib, ibegst, ie, iendst, il, i0, i9, i, ii, in
       parameter (mxd=9)                 ! max. # of digits
 
@@ -186,6 +188,6 @@
 ! ..........................................
 
-      implicit integer*4 (i-n)
-
+      implicit none
+      integer mxd, mxap, mxip, ib, ibegst, ie, iendst, il, ip, ibp
       parameter (mxd =17,   ! max. # of digits
      &           mxap= 6,   ! max. # of digits after period
@@ -292,5 +294,5 @@
 
       integer lun
-
+      integer i, ibegst, j, k
       logical exs
       character*(*) filnam,stat,format